package com.framsticks.core;

import com.framsticks.params.annotations.FramsClassAnnotation;
import com.framsticks.parsers.XmlLoader;
import com.framsticks.util.dispatching.JoinableCollection;
import com.framsticks.util.dispatching.JoinableMonitor;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

import java.io.InputStream;

/**
 * @author Piotr Sniegowski
 */
@FramsClassAnnotation
public class Framsticks extends JoinableCollection<Entity> {
	private static final Logger log = Logger.getLogger(Framsticks.class);

	public Framsticks() {
		PropertyConfigurator.configure(getClass().getResource("/configs/log4j.properties"));
	}

	public static Framsticks loadConfiguration(InputStream stream) {
		return new XmlLoader().load(stream, Framsticks.class);
	}

	public static void main(final String[] args) {

		final Framsticks framsticks = loadConfiguration(Framsticks.class.getResourceAsStream("/configs/framsticks.xml"));

		new JoinableMonitor(framsticks).use().waitFor().drop().join();

		// monitor.use();
		// monitor.waitFor();
		// monitor.drop();
		// monitor.join();

		log.info("exiting main");
	}

	@Override
	public String toString() {
		return "framsticks";
	}

}
