package com.framsticks.gui;

import com.framsticks.params.AccessInterface;
import com.framsticks.params.CompositeParam;
import com.framsticks.params.FramsClass;
// import org.apache.log4j.Logger;

import javax.swing.*;

/**
 * Author: Piotr Śniegowski
 */
@SuppressWarnings("serial")
public abstract class Panel extends JPanel {

	public static class Parameters {
		public final InstanceAtFrame instanceAtFrame;
		public final CompositeParam param;
		public final FramsClass framsClass;

		public Parameters(InstanceAtFrame instanceAtFrame, CompositeParam param, FramsClass framsClass) {
			this.instanceAtFrame = instanceAtFrame;
			this.param = param;
			this.framsClass = framsClass;
		}
	}

	// private static final Logger log = Logger.getLogger(Panel.class.getName());

	protected TreeNode currentTreeNode;
	protected final InstanceAtFrame instanceAtFrame;
	protected final Frame frame;
	protected final String className;
	protected final FramsClass framsClass;
	protected final CompositeParam param;
	protected String uniqueName = "?";

	public Panel(Parameters parameters) {
		this.instanceAtFrame = parameters.instanceAtFrame;
		this.frame = parameters.instanceAtFrame.getFrame();
		this.framsClass = parameters.framsClass;
		this.param = parameters.param;
		this.className = parameters.param.getContainedTypeName();
		this.setName(parameters.param.getFramsTypeName());
	}

	public void setCurrentTreeNode(TreeNode currentTreeNode) {
		this.currentTreeNode = currentTreeNode;
	}

	public TreeNode getCurrentTreeNode() {
		return currentTreeNode;
	}

	public final Frame getFrame() {
		return frame;
	}

	public final InstanceAtFrame getInstanceAtFrame() {
		return instanceAtFrame;
	}


	public final String getClassName() {
		return className;
	}

	public abstract void pullValuesFromLocalToUser(AccessInterface access);

	@Override
	public String toString() {
		return uniqueName;
	}

	public final String getUniqueName() {
		return uniqueName;
	}

	public abstract String getTitle();
}
