package com.framsticks.model.f0;

import org.testng.annotations.*;

import com.framsticks.params.types.FloatParam;
import com.framsticks.test.TestConfiguration;
import com.framsticks.model.f0.Schema;

import static org.fest.assertions.Delta.*;

import static org.fest.assertions.Assertions.*;

public class SchemaTest extends TestConfiguration {

	@Test
	public void loadSchemaWithXmlLoader() {
		Schema schema = Schema.load(Schema.getDefaultDefinitionAsStream());
		assertThat(schema.getFramsClasses().size()).isEqualTo(5);
		assertThat(schema.getNeuroClasses().size()).isEqualTo(21);

		assertThat(schema.getNeuroClass("|").getName()).isEqualTo("Bend muscle");
		assertThat(schema.getNeuroClass("VEye").getParam("p")).isInstanceOf(FloatParam.class);
		assertThat(schema.getNeuroClass("VEye").getParamEntry("p", FloatParam.class).getMax(Double.class)).isEqualTo(10.0, delta(0.0));

		assertThat(schema.getFramsClass("p").getParamEntry("as", FloatParam.class).getDef(Double.class)).isEqualTo(0.25, delta(0.0));
	}

}
